---
default:
  image: ubuntu:jammy
stages:
  - lint
  - validate
  - build

yaml-lint:
  tags:
    - homelab
    - ubuntu
    - temp
  stage: lint
  image:
    name: cytopia/yamllint
    entrypoint: ["/bin/ash", "-c"]
  script:
    - |
      yamllint -f colored  -d "{extends: default, rules: {line-length: {max: 130}}}" .

packer-validate:
  tags:
    - homelab
    - ubuntu
    - temp
  stage: validate
  image:
    name: hashicorp/packer
    entrypoint:
      - '/usr/bin/env'
      - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'
  script:
    - |
      apk update && apk add ansible
      mkdir -p ~/.ssh && echo "$SSH_PRIVATE_KEY_FILE" | base64 -d > ~/.ssh/proxmox && chmod 0600 ~/.ssh/proxmox
      cd packer
      echo "Executing packer init and validation..."
      packer init .
      packer validate .

packer-build:
  tags:
    - homelab
    - ubuntu
    - temp
  stage: build
  image:
    name: hashicorp/packer:light-1.8.4
    entrypoint:
      - '/usr/bin/env'
      - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'
  script:
    - |
      apk update && apk add ansible
      mkdir -p ~/.ssh && echo "$SSH_PRIVATE_KEY_FILE" | base64 -d > ~/.ssh/proxmox && chmod 0600 ~/.ssh/proxmox
      cd packer
      packer init .
      packer build .
